VTK: vtkPentagonalPrism Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | List of all members
vtkPentagonalPrism Class Reference

a 3D cell that represents a convex prism with pentagonal base More...

`#include <vtkPentagonalPrism.h>`

Inheritance diagram for vtkPentagonalPrism:
[legend]
Collaboration diagram for vtkPentagonalPrism:
[legend]

## Public Types
typedef vtkCell3D | Superclass
Public Types inherited from vtkCell3D
typedef vtkCell | Superclass
Public Types inherited from vtkCell
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPentagonalPrism * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | EvaluatePosition (const double x[3], double closestPoint[3], int &subId, double pcoords[3], double &dist2, double weights[]) override
| Given a point x[3] return inside(=1), outside(=0) cell, or (-1) computational problem encountered; evaluate parametric coordinates, sub-cell id (!=0 only if cell is composite), distance squared of point x[3] to cell (in particular, the sub-cell indicated), closest point on cell to x[3] (unless closestPoint is null, in which case, the closest point and dist2 are not found), and interpolation weights in cell. More...
void | EvaluateLocation (int &subId, const double pcoords[3], double x[3], double *weights) override
| Determine global coordinate (x[3]) from subId and parametric coordinates. More...
int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId) override
| Intersect with a ray. More...
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts) override
| Generate simplices of proper dimension. More...
void | Derivatives (int subId, const double pcoords[3], const double *values, int dim, double *derivs) override
| Compute derivatives given cell subId and parametric coordinates. More...
double * | GetParametricCoords () override
| Return a contiguous array of parametric coordinates of the points defining this cell. More...
int | GetParametricCenter (double pcoords[3]) override
| Return the center of the wedge in parametric coordinates. More...
void | JacobianInverse (const double pcoords[3], double **inverse, double derivs[30])
| Given parametric coordinates compute inverse Jacobian transformation matrix. More...
void | GetEdgePoints (vtkIdType edgeId, const vtkIdType *&pts) override
| See vtkCell3D API for description of these methods. More...
vtkIdType | GetFacePoints (vtkIdType faceId, const vtkIdType *&pts) override
| See vtkCell3D API for description of these methods. More...
void | GetEdgeToAdjacentFaces (vtkIdType edgeId, const vtkIdType *&pts) override
| See vtkCell3D API for description of these methods. More...
vtkIdType | GetFaceToAdjacentFaces (vtkIdType faceId, const vtkIdType *&faceIds) override
| See vtkCell3D API for description of these methods. More...
vtkIdType | GetPointToIncidentEdges (vtkIdType pointId, const vtkIdType *&edgeIds) override
| See vtkCell3D API for description of these methods. More...
vtkIdType | GetPointToIncidentFaces (vtkIdType pointId, const vtkIdType *&faceIds) override
| See vtkCell3D API for description of these methods. More...
vtkIdType | GetPointToOneRingPoints (vtkIdType pointId, const vtkIdType *&pts) override
| See vtkCell3D API for description of these methods. More...
bool | GetCentroid (double centroid[3]) const override
| See vtkCell3D API for description of these methods. More...
bool | IsInsideOut () override
| See vtkCell3D API for description of these methods. More...
int | GetCellType () override
| See the vtkCell3D API for descriptions of these methods. More...
int | GetCellDimension () override
| See the vtkCell3D API for descriptions of these methods. More...
int | GetNumberOfEdges () override
| See the vtkCell3D API for descriptions of these methods. More...
int | GetNumberOfFaces () override
| See the vtkCell3D API for descriptions of these methods. More...
vtkCell * | GetEdge (int edgeId) override
| See the vtkCell3D API for descriptions of these methods. More...
vtkCell * | GetFace (int faceId) override
| See the vtkCell3D API for descriptions of these methods. More...
int | CellBoundary (int subId, const double pcoords[3], vtkIdList *pts) override
| See the vtkCell3D API for descriptions of these methods. More...
void | InterpolateFunctions (const double pcoords[3], double weights[10]) override
| Compute the interpolation functions/derivatives (aka shape functions/derivatives) More...
void | InterpolateDerivs (const double pcoords[3], double derivs[30]) override
| Compute the interpolation functions/derivatives (aka shape functions/derivatives) More...
Public Member Functions inherited from vtkCell3D
vtkCell3D * | NewInstance () const
void | Contour (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd) override
| Generate contouring primitives. More...
void | Clip (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *connectivity, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut) override
| Cut (or clip) the cell based on the input cellScalars and the specified value. More...
int | Inflate (double dist) override
| Inflates the cell. More...
virtual void | SetMergeTolerance (double)
| Set the tolerance for merging clip intersection points that are near the vertices of cells. More...
virtual double | GetMergeTolerance ()
| Set the tolerance for merging clip intersection points that are near the vertices of cells. More...
Public Member Functions inherited from vtkCell
vtkCell * | NewInstance () const
void | Initialize (int npts, const vtkIdType *pts, vtkPoints *p)
| Initialize cell from outside with point ids and point coordinates specified. More...
void | Initialize (int npts, vtkPoints *p)
| Initialize the cell with point coordinates specified. More...
virtual void | ShallowCopy (vtkCell *c)
| Copy this cell by reference counting the internal data structures. More...
virtual void | DeepCopy (vtkCell *c)
| Copy this cell by completely copying internal data structures. More...
virtual int | IsLinear ()
| Non-linear cells require special treatment beyond the usual cell type and connectivity list information. More...
virtual int | RequiresInitialization ()
| Some cells require initialization prior to access. More...
virtual void | Initialize ()
virtual int | IsExplicitCell ()
| Explicit cells require additional representational information beyond the usual cell type and connectivity list information. More...
virtual int | RequiresExplicitFaceRepresentation ()
| Determine whether the cell requires explicit face representation, and methods for setting and getting the faces (see vtkPolyhedron for example usage of these methods). More...
virtual void | SetFaces (vtkIdType *vtkNotUsed(faces))
virtual vtkIdType * | GetFaces ()
vtkPoints * | GetPoints ()
| Get the point coordinates for the cell. More...
vtkIdType | GetNumberOfPoints () const
| Return the number of points in the cell. More...
vtkIdList * | GetPointIds ()
| Return the list of point ids defining the cell. More...
vtkIdType | GetPointId (int ptId)
| For cell point i, return the actual point id. More...
virtual double | ComputeBoundingSphere (double center[3]) const
| Computes the bounding sphere of the cell. More...
void | GetBounds (double bounds[6])
| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). More...
double * | GetBounds ()
| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). More...
double | GetLength2 ()
| Compute Length squared of cell (i.e., bounding box diagonal squared). More...
virtual double | GetParametricDistance (const double pcoords[3])
| Return the distance of the parametric coordinate provided to the cell. More...
virtual int | IsPrimaryCell ()
| Return whether this cell type has a fixed topology or whether the topology varies depending on the data (e.g., vtkConvexPointSet). More...
virtual void | InterpolateFunctions (const double vtkNotUsed(pcoords)[3], double *vtkNotUsed(weight))
| Compute the interpolation functions/derivatives (aka shape functions/derivatives) No-ops at this level. More...
virtual void | InterpolateDerivs (const double vtkNotUsed(pcoords)[3], double *vtkNotUsed(derivs))
virtual int | IntersectWithCell (vtkCell *other, double tol=0.0)
| Intersects with an other cell. More...
virtual int | IntersectWithCell (vtkCell *other, const vtkBoundingBox &boudingBox, const vtkBoundingBox &otherBoundingBox, double tol=0.0)
| Intersects with an other cell. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkPentagonalPrism * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPentagonalPrism * | SafeDownCast (vtkObjectBase *o)
static void | InterpolationFunctions (const double pcoords[3], double weights[10])
static void | InterpolationDerivs (const double pcoords[3], double derivs[30])
static const vtkIdType * | GetEdgeToAdjacentFacesArray (vtkIdType edgeId)
| Static method version of GetEdgeToAdjacentFaces. More...
static const vtkIdType * | GetFaceToAdjacentFacesArray (vtkIdType faceId)
| Static method version of GetFaceToAdjacentFaces. More...
static const vtkIdType * | GetPointToIncidentEdgesArray (vtkIdType pointId)
| Static method version of GetPointToIncidentEdgesArray. More...
static const vtkIdType * | GetPointToIncidentFacesArray (vtkIdType pointId)
| Static method version of GetPointToIncidentFacesArray. More...
static const vtkIdType * | GetPointToOneRingPointsArray (vtkIdType pointId)
| Static method version of GetPointToOneRingPoints. More...
static bool | ComputeCentroid (vtkPoints *points, const vtkIdType *pointIds, double centroid[3])
| Static method version of GetCentroid. More...
static const vtkIdType * | GetEdgeArray (vtkIdType edgeId)
| Return the ids of the vertices defining edge/face (`edgeId`/‘faceId’). More...
static const vtkIdType * | GetFaceArray (vtkIdType faceId)
| Return the ids of the vertices defining edge/face (`edgeId`/‘faceId’). More...
Static Public Member Functions inherited from vtkCell3D
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCell3D * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkCell
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCell * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Static Public Attributes
static constexpr vtkIdType | NumberOfPoints = 10
| static constexpr handle on the number of points. More...
static constexpr vtkIdType | NumberOfEdges = 15
| static contexpr handle on the number of faces. More...
static constexpr vtkIdType | NumberOfFaces = 7
| static contexpr handle on the number of edges. More...
static constexpr vtkIdType | MaximumFaceSize = 5
| static contexpr handle on the maximum face size. More...
static constexpr vtkIdType | MaximumValence = 3
| static constexpr handle on the maximum valence of this cell. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPentagonalPrism ()
| ~vtkPentagonalPrism () override
Protected Member Functions inherited from vtkCell3D
| vtkCell3D ()
| ~vtkCell3D () override
Protected Member Functions inherited from vtkCell
| vtkCell ()
| ~vtkCell () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkLine * | Line
vtkQuad * | Quad
vtkPolygon * | Polygon
vtkTriangle * | Triangle
Protected Attributes inherited from vtkCell3D
vtkOrderedTriangulator * | Triangulator
double | MergeTolerance
vtkTetra * | ClipTetra
vtkDoubleArray * | ClipScalars
Protected Attributes inherited from vtkCell
double | Bounds [6]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Public Attributes inherited from vtkCell
vtkPoints * | Points
vtkIdList * | PointIds
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

a 3D cell that represents a convex prism with pentagonal base

vtkPentagonalPrism is a concrete implementation of vtkCell to represent a linear convex 3D prism with pentagonal base. Such prism is defined by the ten points (0-9), where (0,1,2,3,4) is the base of the prism which, using the right hand rule, forms a pentagon whose normal points is in the direction of the opposite face (5,6,7,8,9).

Thanks:
  Thanks to Philippe Guerville who developed this class. Thanks to Charles Pignerol (CEA-DAM, France) who ported this class under VTK 4.
  Thanks to Jean Favre (CSCS, Switzerland) who contributed to integrate this class in VTK.
  Please address all comments to Jean Favre (jfavre at cscs.ch).

Thanks:
  The Interpolation functions and derivatives were changed in June 2015 by Bill Lorensen. These changes follow the formulation in: http://dilbert.engr.ucdavis.edu/~suku/nem/papers/polyelas.pdf NOTE: An additional copy of this paper is located at: http://www.vtk.org/Wiki/File:ApplicationOfPolygonalFiniteElementsInLinearElasticity.pdf

Online Examples:

Tests:
  vtkPentagonalPrism (Tests)

Definition at line 54 of file vtkPentagonalPrism.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkCell3D vtkPentagonalPrism::Superclass

Definition at line 58 of file vtkPentagonalPrism.h.

## Constructor & Destructor Documentation

## ◆ vtkPentagonalPrism()

vtkPentagonalPrism::vtkPentagonalPrism | ( |  | ) |
| protected

## ◆ ~vtkPentagonalPrism()

vtkPentagonalPrism::~vtkPentagonalPrism | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkPentagonalPrism* vtkPentagonalPrism::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkPentagonalPrism::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPentagonalPrism::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkCell3D.

## ◆ SafeDownCast()

static vtkPentagonalPrism* vtkPentagonalPrism::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPentagonalPrism::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkCell3D.

## ◆ NewInstance()

vtkPentagonalPrism* vtkPentagonalPrism::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPentagonalPrism::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkCell3D.

## ◆ GetEdgePoints()

void vtkPentagonalPrism::GetEdgePoints | ( | vtkIdType | edgeId,
|  | const vtkIdType *& | pts
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetFacePoints()

vtkIdType vtkPentagonalPrism::GetFacePoints | ( | vtkIdType | faceId,
|  | const vtkIdType *& | pts
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetEdgeToAdjacentFaces()

void vtkPentagonalPrism::GetEdgeToAdjacentFaces | ( | vtkIdType | edgeId,
|  | const vtkIdType *& | pts
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetFaceToAdjacentFaces()

vtkIdType vtkPentagonalPrism::GetFaceToAdjacentFaces | ( | vtkIdType | faceId,
|  | const vtkIdType *& | faceIds
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetPointToIncidentEdges()

vtkIdType vtkPentagonalPrism::GetPointToIncidentEdges | ( | vtkIdType | pointId,
|  | const vtkIdType *& | edgeIds
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetPointToIncidentFaces()

vtkIdType vtkPentagonalPrism::GetPointToIncidentFaces | ( | vtkIdType | pointId,
|  | const vtkIdType *& | faceIds
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetPointToOneRingPoints()

vtkIdType vtkPentagonalPrism::GetPointToOneRingPoints | ( | vtkIdType | pointId,
|  | const vtkIdType *& | pts
| ) |  |
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ GetCentroid()

bool vtkPentagonalPrism::GetCentroid | ( | double | centroid[3] | ) | const
| overridevirtual

See vtkCell3D API for description of these methods.

Implements vtkCell3D.

## ◆ IsInsideOut()

bool vtkPentagonalPrism::IsInsideOut | ( |  | ) |
| overridevirtual

See vtkCell3D API for description of these methods.

Reimplemented from vtkCell3D.

## ◆ GetCellType()

int vtkPentagonalPrism::GetCellType | ( |  | ) |
| inlineoverridevirtual

See the vtkCell3D API for descriptions of these methods.

Implements vtkCell.

Definition at line 108 of file vtkPentagonalPrism.h.

## ◆ GetCellDimension()

int vtkPentagonalPrism::GetCellDimension | ( |  | ) |
| inlineoverridevirtual

See the vtkCell3D API for descriptions of these methods.

Reimplemented from vtkCell3D.

Definition at line 109 of file vtkPentagonalPrism.h.

## ◆ GetNumberOfEdges()

int vtkPentagonalPrism::GetNumberOfEdges | ( |  | ) |
| inlineoverridevirtual

See the vtkCell3D API for descriptions of these methods.

Implements vtkCell.

Definition at line 110 of file vtkPentagonalPrism.h.

## ◆ GetNumberOfFaces()

int vtkPentagonalPrism::GetNumberOfFaces | ( |  | ) |
| inlineoverridevirtual

See the vtkCell3D API for descriptions of these methods.

Implements vtkCell.

Definition at line 111 of file vtkPentagonalPrism.h.

## ◆ GetEdge()

vtkCell* vtkPentagonalPrism::GetEdge | ( | int | edgeId | ) |
| overridevirtual

See the vtkCell3D API for descriptions of these methods.

Implements vtkCell.

## ◆ GetFace()

vtkCell* vtkPentagonalPrism::GetFace | ( | int | faceId | ) |
| overridevirtual

See the vtkCell3D API for descriptions of these methods.

Implements vtkCell.

## ◆ CellBoundary()

int vtkPentagonalPrism::CellBoundary | ( | int | subId,
|  | const double | pcoords[3],
|  | vtkIdList * | pts
| ) |  |
| overridevirtual

See the vtkCell3D API for descriptions of these methods.

Implements vtkCell.

## ◆ EvaluatePosition()

int vtkPentagonalPrism::EvaluatePosition | ( | const double | x[3],
|  | double | closestPoint[3],
|  | int & | subId,
|  | double | pcoords[3],
|  | double & | dist2,
|  | double | weights[]
| ) |  |
| overridevirtual

Given a point x[3] return inside(=1), outside(=0) cell, or (-1) computational problem encountered; evaluate parametric coordinates, sub-cell id (!=0 only if cell is composite), distance squared of point x[3] to cell (in particular, the sub-cell indicated), closest point on cell to x[3] (unless closestPoint is null, in which case, the closest point and dist2 are not found), and interpolation weights in cell.

(The number of weights is equal to the number of points defining the cell). Note: on rare occasions a -1 is returned from the method. This means that numerical error has occurred and all data returned from this method should be ignored. Also, inside/outside is determine parametrically. That is, a point is inside if it satisfies parametric limits. This can cause problems for cells of topological dimension 2 or less, since a point in 3D can project onto the cell within parametric limits but be "far" from the cell. Thus the value dist2 may be checked to determine true in/out.

Implements vtkCell.

## ◆ EvaluateLocation()

void vtkPentagonalPrism::EvaluateLocation | ( | int & | subId,
|  | const double | pcoords[3],
|  | double | x[3],
|  | double * | weights
| ) |  |
| overridevirtual

Determine global coordinate (x[3]) from subId and parametric coordinates.

Also returns interpolation weights. (The number of weights is equal to the number of points in the cell.)

Implements vtkCell.

## ◆ IntersectWithLine()

int vtkPentagonalPrism::IntersectWithLine | ( | const double | p1[3],
|  | const double | p2[3],
|  | double | tol,
|  | double & | t,
|  | double | x[3],
|  | double | pcoords[3],
|  | int & | subId
| ) |  |
| overridevirtual

Intersect with a ray.

Return parametric coordinates (both line and cell) and global intersection coordinates, given ray definition p1[3], p2[3] and tolerance tol. The method returns non-zero value if intersection occurs. A parametric distance t between 0 and 1 along the ray representing the intersection point, the point coordinates x[3] in data coordinates and also pcoords[3] in parametric coordinates. subId is the index within the cell if a composed cell like a triangle strip.

Implements vtkCell.

## ◆ Triangulate()

int vtkPentagonalPrism::Triangulate | ( | int | index,
|  | vtkIdList * | ptIds,
|  | vtkPoints * | pts
| ) |  |
| overridevirtual

Generate simplices of proper dimension.

If cell is 3D, tetrahedron are generated; if 2D triangles; if 1D lines; if 0D points. The form of the output is a sequence of points, each n+1 points (where n is topological cell dimension) defining a simplex. The index is a parameter that controls which triangulation to use (if more than one is possible). If numerical degeneracy encountered, 0 is returned, otherwise 1 is returned. This method does not insert new points: all the points that define the simplices are the points that define the cell.

Implements vtkCell.

## ◆ Derivatives()

void vtkPentagonalPrism::Derivatives | ( | int | subId,
|  | const double | pcoords[3],
|  | const double * | values,
|  | int | dim,
|  | double * | derivs
| ) |  |
| overridevirtual

Compute derivatives given cell subId and parametric coordinates.

The values array is a series of data value(s) at the cell points. There is a one-to-one correspondence between cell point and data value(s). Dim is the number of data values per cell point. Derivs are derivatives in the x-y-z coordinate directions for each data value. Thus, if computing derivatives for a scalar function in a hexahedron, dim=1, 8 values are supplied, and 3 deriv values are returned (i.e., derivatives in x-y-z directions). On the other hand, if computing derivatives of velocity (vx,vy,vz) dim=3, 24 values are supplied ((vx,vy,vz)1, (vx,vy,vz)2, ....()8), and 9 deriv values are returned ((d(vx)/dx),(d(vx)/dy),(d(vx)/dz), (d(vy)/dx),(d(vy)/dy), (d(vy)/dz), (d(vz)/dx),(d(vz)/dy),(d(vz)/dz)).

Implements vtkCell.

## ◆ GetParametricCoords()

double* vtkPentagonalPrism::GetParametricCoords | ( |  | ) |
| overridevirtual

Return a contiguous array of parametric coordinates of the points defining this cell.

In other words, (px,py,pz, px,py,pz, etc..) The coordinates are ordered consistent with the definition of the point ordering for the cell. This method returns a non-nullptr pointer when the cell is a primary type (i.e., IsPrimaryCell() is true). Note that 3D parametric coordinates are returned no matter what the topological dimension of the cell.

Reimplemented from vtkCell.

## ◆ GetParametricCenter()

int vtkPentagonalPrism::GetParametricCenter | ( | double | pcoords[3] | ) |
| inlineoverridevirtual

Return the center of the wedge in parametric coordinates.

Reimplemented from vtkCell.

Definition at line 214 of file vtkPentagonalPrism.h.

## ◆ InterpolationFunctions()

static void vtkPentagonalPrism::InterpolationFunctions | ( | const double | pcoords[3],
|  | double | weights[10]
| ) |  |
| static

## ◆ InterpolationDerivs()

static void vtkPentagonalPrism::InterpolationDerivs | ( | const double | pcoords[3],
|  | double | derivs[30]
| ) |  |
| static

## ◆ InterpolateFunctions()

void vtkPentagonalPrism::InterpolateFunctions | ( | const double | pcoords[3],
|  | double | weights[10]
| ) |  |
| inlineoverride

Compute the interpolation functions/derivatives (aka shape functions/derivatives)

Definition at line 139 of file vtkPentagonalPrism.h.

## ◆ InterpolateDerivs()

void vtkPentagonalPrism::InterpolateDerivs | ( | const double | pcoords[3],
|  | double | derivs[30]
| ) |  |
| inlineoverride

Compute the interpolation functions/derivatives (aka shape functions/derivatives)

Definition at line 143 of file vtkPentagonalPrism.h.

## ◆ GetEdgeArray()

static const vtkIdType* vtkPentagonalPrism::GetEdgeArray | ( | vtkIdType | edgeId | ) |
| static

Return the ids of the vertices defining edge/face (`edgeId`/‘faceId’).

Ids are related to the cell, not to the dataset.

Note
  The return type changed. It used to be int*, it is now const vtkIdType*. This is so ids are unified between vtkCell and vtkPoints, and so vtkCell ids can be used as inputs in algorithms such as vtkPolygon::ComputeNormal.

## ◆ GetFaceArray()

static const vtkIdType* vtkPentagonalPrism::GetFaceArray | ( | vtkIdType | faceId | ) |
| static

Return the ids of the vertices defining edge/face (`edgeId`/‘faceId’).

Ids are related to the cell, not to the dataset.

Note
  The return type changed. It used to be int*, it is now const vtkIdType*. This is so ids are unified between vtkCell and vtkPoints, and so vtkCell ids can be used as inputs in algorithms such as vtkPolygon::ComputeNormal.

## ◆ GetEdgeToAdjacentFacesArray()

static const vtkIdType* vtkPentagonalPrism::GetEdgeToAdjacentFacesArray | ( | vtkIdType | edgeId | ) |
| static

Static method version of GetEdgeToAdjacentFaces.

## ◆ GetFaceToAdjacentFacesArray()

static const vtkIdType* vtkPentagonalPrism::GetFaceToAdjacentFacesArray | ( | vtkIdType | faceId | ) |
| static

Static method version of GetFaceToAdjacentFaces.

## ◆ GetPointToIncidentEdgesArray()

static const vtkIdType* vtkPentagonalPrism::GetPointToIncidentEdgesArray | ( | vtkIdType | pointId | ) |
| static

Static method version of GetPointToIncidentEdgesArray.

## ◆ GetPointToIncidentFacesArray()

static const vtkIdType* vtkPentagonalPrism::GetPointToIncidentFacesArray | ( | vtkIdType | pointId | ) |
| static

Static method version of GetPointToIncidentFacesArray.

## ◆ GetPointToOneRingPointsArray()

static const vtkIdType* vtkPentagonalPrism::GetPointToOneRingPointsArray | ( | vtkIdType | pointId | ) |
| static

Static method version of GetPointToOneRingPoints.

## ◆ ComputeCentroid()

static bool vtkPentagonalPrism::ComputeCentroid | ( | vtkPoints * | points,
|  | const vtkIdType * | pointIds,
|  | double | centroid[3]
| ) |  |
| static

Static method version of GetCentroid.

## ◆ JacobianInverse()

void vtkPentagonalPrism::JacobianInverse | ( | const double | pcoords[3],
|  | double ** | inverse,
|  | double | derivs[30]
| ) |  |

Given parametric coordinates compute inverse Jacobian transformation matrix.

Returns 9 elements of 3x3 inverse Jacobian plus interpolation function derivatives.

## Member Data Documentation

## ◆ NumberOfPoints

constexpr vtkIdType vtkPentagonalPrism::NumberOfPoints = 10
| staticconstexpr

static constexpr handle on the number of points.

Definition at line 79 of file vtkPentagonalPrism.h.

## ◆ NumberOfEdges

constexpr vtkIdType vtkPentagonalPrism::NumberOfEdges = 15
| staticconstexpr

static contexpr handle on the number of faces.

Definition at line 84 of file vtkPentagonalPrism.h.

## ◆ NumberOfFaces

constexpr vtkIdType vtkPentagonalPrism::NumberOfFaces = 7
| staticconstexpr

static contexpr handle on the number of edges.

Definition at line 89 of file vtkPentagonalPrism.h.

## ◆ MaximumFaceSize

constexpr vtkIdType vtkPentagonalPrism::MaximumFaceSize = 5
| staticconstexpr

static contexpr handle on the maximum face size.

It can also be used to know the number of faces adjacent to one face.

Definition at line 95 of file vtkPentagonalPrism.h.

## ◆ MaximumValence

constexpr vtkIdType vtkPentagonalPrism::MaximumValence = 3
| staticconstexpr

static constexpr handle on the maximum valence of this cell.

The valence of a vertex is the number of incident edges (or equivalently faces) to this vertex. It is also equal to the size of a one ring neighborhood of a vertex.

Definition at line 102 of file vtkPentagonalPrism.h.

## ◆ Line

vtkLine* vtkPentagonalPrism::Line
| protected

Definition at line 203 of file vtkPentagonalPrism.h.

## ◆ Quad

vtkQuad* vtkPentagonalPrism::Quad
| protected

Definition at line 204 of file vtkPentagonalPrism.h.

## ◆ Polygon

vtkPolygon* vtkPentagonalPrism::Polygon
| protected

Definition at line 205 of file vtkPentagonalPrism.h.

## ◆ Triangle

vtkTriangle* vtkPentagonalPrism::Triangle
| protected

Definition at line 206 of file vtkPentagonalPrism.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkPentagonalPrism.h